classification
Title: erroneous comments in dictobject.c
Type: behavior Stage: resolved
Components: Interpreter Core Versions: Python 3.7, Python 3.6, Python 3.5
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: methane Nosy List: Jim.Jewett, berker.peksag, methane
Priority: normal Keywords: patch

Created on 2015-05-24 04:49 by Jim.Jewett, last changed 2017-02-20 13:59 by methane. This issue is now closed.

Files
File name Uploaded Description Edit
lookdict_unicode_comment.patch methane, 2016-09-29 07:47
Pull Requests
URL Status Linked Edit
PR 194 merged methane, 2017-02-20 11:11
PR 196 merged methane, 2017-02-20 11:34
PR 200 merged methane, 2017-02-20 13:50
Messages (6)
msg243968 - (view) Author: Jim Jewett (Jim.Jewett) * (Python triager) Date: 2015-05-24 04:49
https://hg.python.org/cpython/file/2df7c958974e/Objects/dictobject.c#l451

The comments near lookdict suggest that specialized versions such as lookdict_unicode and lookdict_unicode_nodummy cannot return NULL, as that would indicate an Exception was raised during comparison.

They can return NULL, because if the *search* key is not unicode, they replace themselves with the generic lookdict and then return its result, which may be NULL.
msg277673 - (view) Author: Berker Peksag (berker.peksag) * (Python committer) Date: 2016-09-28 23:01
Comments have been updated by the new dict implementation in 3.6+, but the 3.5 branch still needs to be updated.
msg288193 - (view) Author: Inada Naoki (methane) * (Python committer) Date: 2017-02-20 11:28
https://github.com/python/cpython/pull/194#issuecomment-281054701

Xiang Zhang found Python 3.6+ have similar issue.
msg288194 - (view) Author: Inada Naoki (methane) * (Python committer) Date: 2017-02-20 11:29
New changeset 66fa9d4205e0da672ed19a397069281a4b177af4 by GitHub in branch '3.5':
bpo-24274: fix comment in dictobject.c (GH-194)
https://github.com/python/cpython/commit/66fa9d4205e0da672ed19a397069281a4b177af4
msg288203 - (view) Author: Inada Naoki (methane) * (Python committer) Date: 2017-02-20 13:48
New changeset 1b8df107f867fb05ff39ebee7c55f0a907e7ad5f by GitHub in branch 'master':
bpo-24274: fix erroneous comment in dictobject.c (GH-196)
https://github.com/python/cpython/commit/1b8df107f867fb05ff39ebee7c55f0a907e7ad5f
msg288204 - (view) Author: Inada Naoki (methane) * (Python committer) Date: 2017-02-20 13:58
New changeset ce552e2d5c4ff90218fb41847e8ffb1fd3ba3b2d by GitHub in branch '3.6':
bpo-24274: fix erroneous comment in dictobject.c (GH-200)
https://github.com/python/cpython/commit/ce552e2d5c4ff90218fb41847e8ffb1fd3ba3b2d
History
Date User Action Args
2017-02-20 13:59:35methanesetstatus: open -> closed
resolution: fixed
stage: patch review -> resolved
2017-02-20 13:58:13methanesetmessages: + msg288204
2017-02-20 13:50:55methanesetpull_requests: + pull_request167
2017-02-20 13:48:12methanesetmessages: + msg288203
2017-02-20 11:34:59methanesetpull_requests: + pull_request163
2017-02-20 11:29:32methanesetmessages: + msg288194
2017-02-20 11:28:24methanesetmessages: + msg288193
versions: + Python 3.6, Python 3.7
2017-02-20 11:11:06methanesetpull_requests: + pull_request161
2016-10-01 08:36:24methanesetassignee: methane
stage: needs patch -> patch review
2016-09-29 07:47:29methanesetfiles: + lookdict_unicode_comment.patch
keywords: + patch
2016-09-28 23:01:22berker.peksagsetversions: + Python 3.5
nosy: + berker.peksag, methane

messages: + msg277673

type: enhancement -> behavior
stage: needs patch
2015-05-24 04:49:12Jim.Jewettcreate